unit MDIFrame;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  Menus,comctrls,math,unit3, Coding, unit7, unit8;

type  PCodeArray = ^TCodeArray;
      TCodeArray = record
        Symbol : Char;
          Code : ShortString;
  Counter,Kol_vo : integer;
     Next,Prev : PCodeArray;
end;

 {    TFileCodeArray = record
        Symbol : Char;
          Code : integer;
Counter,Kol_vo : integer;
end;             }

type
  TfrmMain = class(TForm)
    MainMenu: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    OpenFileDialog: TOpenDialog;
    Coding_: TMenuItem;
    CodeCreate: TMenuItem;
    OpenSRCDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    Transmission: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure Arrangeicons1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure CodeCreateClick(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure TransmissionClick(Sender: TObject);
    procedure N5Click(Sender: TObject);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

   procedure Statistic(FileName:string);
   procedure CreateSpis(var Top:PCodeArray);
   procedure DeleteSpis(Top:PCodeArray);
   procedure AddToSpis(Top:PCodeArray;Symb:Char);
   function  SearchArray(Top:PCodeArray;Symb:Char):boolean;
   function  GlobalEntropy(Top:PCodeArray):real;
   procedure SpisToFile(Top:PCodeArray);
   procedure AddCodeToSpis(Top:PCodeArray);
   procedure AddCodeToForm(Top:PCodeArray);
//   Procedure AddFileToSpis(f:file of TCodeArray);
   procedure CreateCode;
var
  frmMain: TfrmMain;
  CodeArray:PCodeArray;
  VsegoSimv:integer;
  Entropy:integer;
  SourceFile,SF: string;

implementation

uses MDIEdit, Unit1 , Unit4;

{$R *.DFM}


function GlobalEntropy(Top:PCodeArray):real;
var      E:real;
begin E:=0;
   While Top^.Next<>nil do
      begin
E:=E+(Top^.Kol_vo/VsegoSimv*ln(Top^.Kol_vo/VsegoSimv)/ln(2));
         Top:=Top^.Next;
      end;
E:=(-1)*(E+(Top^.Kol_vo/VsegoSimv*ln(Top^.Kol_vo/VsegoSimv)/ln(2)));
GlobalEntropy:=E;
end;

procedure Statistic(FileName:string);
label 1;
var       F:TextFile;
          S:Char;
begin
    AssignFile(F, FileName);
    Reset(F);
    CreateSpis(CodeArray);
if not EOF(F) then begin
    Read(F,CodeArray^.Symbol);
    VsegoSimv:=1;
    CodeArray^.Kol_vo:=1;
                   end
else  begin
 MessageDlg(' ', mtInformation,
      [mbOk], 0);
      DeleteSpis(CodeArray);
      Goto 1;
      end;

  While not EOF(F) do
     begin
       Read(F,S);
       VsegoSimv:=VsegoSimv+1;
       if SearchArray(CodeArray,S) = False then AddToSpis(CodeArray,S);
     end;
  1: CloseFile(F);
//   DeleteSpis(CodeArray);     // DESTROY This !!!!!!!!!!!!!!
end;

procedure CreateSpis(var Top:PCodeArray);
begin
            New(Top);
         Top^.Symbol := ' ';
           Top^.Code := '';
        Top^.Counter := 0;
         Top^.Kol_vo := 0;
           Top^.Next := Nil;
           Top^.Prev := Nil;
end;

procedure DeleteSpis(Top:PCodeArray);
var Current: PCodeArray;
begin  while Top<>nil do
     begin  Current:=Top;
            Top:=Top^.Next;
            Dispose(Current); // ??? heap memory ???
     end;
end;

procedure AddToSpis(Top:PCodeArray;Symb:Char);
var // Storage:PCodeArray;
    NewElement:PCodeArray;
begin  // Storage:=Top;
  while Top^.Next<>nil do Top:=Top^.Next;
           New(NewElement);
           NewElement^.Symbol:=Symb;
           NewElement^.Kol_vo:=1;
           NewElement^.Counter:=Top^.Counter+1;
           NewElement^.Next := nil;
             Top^.Next:= NewElement;
             NewElement^.Prev:=Top;
         //    Top:=Storage;
end;

function  SearchArray(Top:PCodeArray;Symb:Char):boolean;
// var Storage:PCodeArray;
begin   // Storage:=Top;
        SearchArray:=False;
while Top^.Next<>nil do
     begin  if  Top^.Symbol=Symb then
               begin  Top^.Kol_vo := Top^.Kol_vo + 1;
                      SearchArray:=True;
                      Break;
               end
            else  Top:=Top^.Next;
     end;

     if   Top^.Next=nil then
       if Top^.Symbol=Symb then begin
           Top^.Kol_vo := Top^.Kol_vo + 1;
           SearchArray:=True;
                                 end;

//       Top:=Storage;
end;

procedure TfrmMain.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.New1Click(Sender: TObject);
begin
  TEditForm.Create(Self);
end;

procedure TfrmMain.Tile1Click(Sender: TObject);
begin
  Tile;
end;

procedure TfrmMain.Cascade1Click(Sender: TObject);
begin
  Cascade;
end;

procedure TfrmMain.Arrangeicons1Click(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TfrmMain.Open1Click(Sender: TObject);
begin
  if OpenFileDialog.Execute then
  with TEditForm.Create(Self) do
    Open(OpenFileDialog.FileName);
end;

procedure TfrmMain.CodeCreateClick(Sender: TObject);
{label 1;}
var
    Storage:PCodeArray;
//    NewItem: TListItem;
    S:shortstring;
  //  i:integer;
begin  { If Form1.Active=true then goto 1;}
   if TForm(Application.FindComponent('Form1')).Visible
      then Exit;
   if OpenSRCDialog1.Execute then begin
      SourceFile:= OpenSRCDialog1.FileName;
      Form1.Show;
      Form1.Label1.Caption:=SourceFile;
      SF:=SourceFile;
      Form1.Button2.Enabled:=true;
      Statistic(SourceFile);
      Str(VsegoSimv,S);
      Form1.Gauge1.MaxValue:=VsegoSimv;
      Form1.StatusBar1.SimpleText:='';
      Form1.Label4.Caption:=S;
      Str(globalentropy(CodeArray):4:4,S);
      Form1.Label5.Caption:=S;
      Storage:=CodeArray;
{  if  Form1.ListBox2.Items.Count<>0 then
         Form1.ListBox2.Items.Clear;
  if  Form1.ListBox3.Items.Count<>0 then
         Form1.ListBox3.Items.Clear;}

     while CodeArray^.Next<>nil do begin
          S:=CodeArray^.Symbol;
          Form1.ListBox3.Items.Add(S);
          Str(CodeArray^.Kol_vo,S);
          Form1.ListBox2.Items.Add(S);
          CodeArray:=CodeArray^.Next;
                                     end;
     S:=CodeArray^.Symbol;
     Form1.ListBox3.Items.Add(S);
     Str(CodeArray^.Kol_vo,S);
     Form1.ListBox2.Items.Add(S);

//        CodeArray:=Storage;
  //        Form1.ListView2.Items.Index:=0;

   CodeArray:=Storage;
//   Storage:=nil;
   end;
{ 1:}
end;

procedure TfrmMain.N3Click(Sender: TObject);
begin
   with TAboutBox.Create(Application) do
        try
         ShowModal;
        finally
         Free;
        end;
end;

procedure AddCodeToSpis(Top:PCodeArray);
begin  while Top<>nil do
       begin
       Top^.Code:=Coding_CharToString(Top^.Symbol);
       Top:=Top^.Next;
       end;
end;


procedure CreateCode;
var  f_in:Textfile;
     f_out:textfile;
     DestinFile:string;
     S:char;
     Storage:PCodeArray;
    // i:integer;
begin
       AssignFile(f_in,SourceFile);
        SetLength(SourceFile,Length(SourceFile)-3);
 //       SourceFile[0]:= StrLen(SourceFile)-3;
        DestinFile:=SourceFile;
     //   DestinFile:=DestinFile+'_';
        DestinFile:=DestinFile+'bc_';
    //    SourceFile:=SourceFile+'txt';
       AssignFile(f_out,DestinFile);
       Reset(f_in);
       Rewrite(f_out);
      Storage:=CodeArray;
       AddCodeToSpis(CodeArray);
       AddCodeToForm(CodeArray);
       Form1.StatusBar1.SimpleText:=
          ', ...   ...';
       Form1.StatusBar1.Update;
  while not EOF(f_in) do
      begin
             read(f_in,S);
 Form1.Gauge1.Progress:=Form1.Gauge1.Progress+1;
       while CodeArray<>nil do
          begin
                 if S=CodeArray^.Symbol then  begin
                 write(f_out,CodeArray^.Code);
                 Break;
                                              end;
           CodeArray:=CodeArray^.Next;
          end;
         CodeArray:=Storage;
         SpisToFile(CodeArray);
     end ;
//        Storage:=nil;
         SourceFile:=SF;
         CloseFile(F_in);
         CloseFile(F_out);
         DeleteSpis(CodeArray);
         Form1.StatusBar1.SimpleText:= '.';
         Form1.Gauge1.Progress:= 0;
         Form1.Button2.Enabled:=false;
end;

procedure  AddCodeToForm(Top:PCodeArray);
 var S:string;
begin
     if  Form1.ListBox1.Items.Count<>0 then
         Form1.ListBox1.Items.Clear;

      while Top<>nil do  begin
          S:=Top^.Code;
          Form1.ListBox1.Items.Add(S);
          Top:=Top^.Next;
                         end;
end;

Procedure SpisToFile(Top:PCodeArray);
var  SpisFile: file of TCodeArray;
        Temp: TCodeArray;
        S:string;
//        i:integer;

begin   S:=SourceFile;
        S:=S+'cod';
    // SourceFile:=SourceFile+'cod';
        AssignFile(SpisFile,S);
        rewrite(SpisFile);
       while Top<>nil do
           begin {Temp.Symbol:=Top^.Symbol;
                 StrPCopy(Top^.Code,Temp.Code,i);
                 Temp.Counter:=Top^.Counter;
                 Temp.Kol_vo:=Top^.Kol_vo;
                 write(SpisFile,Temp);}
               Temp:=Top^;
               Temp.Prev:=nil;
               Temp.Next:=nil;
               write(SpisFile,Temp);
                 Top:=Top^.Next;

           end;
           CloseFile(SpisFile);
end;


procedure TfrmMain.N4Click(Sender: TObject);
begin
          Decode.Show;
          Decode.StatusBar1.SimpleText:='';
end;

procedure TfrmMain.TransmissionClick(Sender: TObject);
begin
  {     with TTransForm.Create(Application) do
        try
         ShowModal;
        finally
         Free;
        end; }
       TransForm.Show;
end;

procedure TfrmMain.N5Click(Sender: TObject);
begin
    with TForm8.Create(Application) do
        try
         ShowModal;
        finally
         Free;
        end;
//      Form8.Show;
end;

end.
